<?php
/**
 * Property Management Company functions and definitions
 *
 * @link https://developer.wordpress.org/themes/basics/theme-functions/
 *
 * @package property-management-company
 * @since property-management-company 1.0
 */

if ( ! function_exists( 'property_management_company_support' ) ) :

	/**
	 * Sets up theme defaults and registers support for various WordPress features.
	 *
	 * @since property-management-company 1.0
	 *
	 * @return void
	 */
	function property_management_company_support() {

		load_theme_textdomain( 'property-management-company', get_template_directory() . '/languages' );
		
		// Add default posts and comments RSS feed links to head.
		add_theme_support( 'automatic-feed-links' );

		// Add support for block styles.
		add_theme_support( 'wp-block-styles' );

		add_theme_support( 'align-wide' );

		// Enqueue editor styles.
		add_editor_style( 'style.css' );

		add_theme_support( 'responsive-embeds' );
		
		// Add support for experimental link color control.
		add_theme_support( 'experimental-link-color' );
	}

endif;

add_action( 'after_setup_theme', 'property_management_company_support' );

if ( ! function_exists( 'property_management_company_styles' ) ) :

	/**
	 * Enqueue styles.
	 *
	 * @since property-management-company 1.0
	 *
	 * @return void
	 */
	function property_management_company_styles() {

		// Register theme stylesheet.
		wp_register_style(
			'property-management-company-style',
			get_template_directory_uri() . '/style.css',
			array(),
			wp_get_theme()->get( 'Version' )
		);

		wp_enqueue_style( 
			'property-management-company-animate-css',
			esc_url(get_template_directory_uri()).'/assets/css/animate.css' 
		);

		// Enqueue theme stylesheet.
		wp_enqueue_style( 'property-management-company-style' );

		wp_enqueue_style( 'dashicons' );

		wp_style_add_data( 'property-management-company-style', 'rtl', 'replace' );

		wp_enqueue_style('property-management-company-swiper-css',
		esc_url(get_template_directory_uri()) . '/assets/css/swiper-bundle.css',
		array()
		);
	}

endif;

/* Enqueue Custom Js */
function property_management_company_scripts() {

	wp_enqueue_script( 
		'property-management-company-custom', esc_url(get_template_directory_uri()) . '/assets/js/custom.js', 
		array('jquery') 
	);

	wp_enqueue_script( 
		'property-management-company-wow', esc_url(get_template_directory_uri()) . '/assets/js/wow.js', 
		array('jquery') 
	);

	wp_enqueue_script(
        'property-management-company-scroll-to-top', 
        esc_url(get_template_directory_uri()) . '/assets/js/scroll-to-top.js', 
        array(), 
        null, 
        true // Load in footer
    );

    wp_enqueue_script(
		'property-management-company-swiper-js',
		esc_url(get_template_directory_uri()) . '/assets/js/swiper-bundle.js',
		array(),
		true
	);
}
add_action( 'wp_enqueue_scripts', 'property_management_company_scripts' );

add_action( 'wp_enqueue_scripts', 'property_management_company_styles' );

/* Enqueue admin-notice-script js */
add_action('admin_enqueue_scripts', function ($hook) {
    if ($hook !== 'appearance_page_property-management-company') return;

    wp_enqueue_script('admin-notice-script', get_template_directory_uri() . '/get-started/js/admin-notice-script.js', ['jquery'], null, true);
    wp_localize_script('admin-notice-script', 'pluginInstallerData', [
        'ajaxurl'     => admin_url('admin-ajax.php'),
        'nonce'       => wp_create_nonce('install_plugin_nonce'), // Match this with PHP nonce check
        'redirectUrl' => admin_url('themes.php?page=property-management-company'),
    ]);
});

add_action('wp_ajax_check_plugin_activation', function () {
    if (!isset($_POST['plugin']) || empty($_POST['plugin'])) {
        wp_send_json_error(['message' => 'Missing plugin identifier']);
    }

    include_once ABSPATH . 'wp-admin/includes/plugin.php';

    // Map plugin identifiers to their main files
    $property_management_company_plugin_map = [
        'woocommerce'          => 'woocommerce/woocommerce.php',
        'wordclever_ai_content_writer'    => 'wordclever-ai-content-writer/wordclever.php',
    ];

    $property_management_company_requested_plugin = sanitize_text_field($_POST['plugin']);

    if (!isset($property_management_company_plugin_map[$property_management_company_requested_plugin])) {
        wp_send_json_error(['message' => 'Invalid plugin']);
    }

    $property_management_company_plugin_file = $property_management_company_plugin_map[$property_management_company_requested_plugin];
    $property_management_company_is_active   = is_plugin_active($property_management_company_plugin_file);

    wp_send_json_success(['active' => $property_management_company_is_active]);
});

add_filter( 'woocommerce_enable_setup_wizard', '__return_false' );

function property_management_company_theme_setting() {
	// Add block patterns
	require get_template_directory() . '/inc/block-pattern.php';

	// Add block Style
	require get_template_directory() . '/inc/block-style.php';

	// TGM
	require get_template_directory() . '/inc/tgm/plugin-activation.php';

	// Add Customizer
	require get_template_directory() . '/inc/customizer.php';

	// Get Started
	require get_template_directory() . '/get-started/getstart.php';

	// Notice
	require get_template_directory() . '/get-started/notice.php';

}	
add_action('after_setup_theme', 'property_management_company_theme_setting');	